/* converts a pbm file to a postscript file.
 *
 * Copyright 1996 Toolshed Technologies Inc. 
 * Written by Andrew Hunt <andy@toolshed.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 */ 


#include <stdio.h>

int
to_points(int i)
{
	return (i * 0.24);
}

main(int argc, char **argv)
{
	int count = 0;
	char type[80];
	char comment[80];
	int width, height;
	int c;
	int byte_count = 0;
	int offset;

	if (argc >1)
		offset = atoi(argv[1]);
	else
		offset = 160;

	gets(type);
	gets(comment);
	scanf("%d %d\n",&width, &height);

	printf ("%%!PS-Adobe-2.0 EPSF-2.0\n");
	printf ("%%%%Title: SCAN OUTPUT\n");
	printf ("%%%%Creator: pbm2ps\n");
	printf ("%% Original size: %dx%d pixels\n",width,height);
	printf ("%%%%BoundingBox: 0 0 %d %d\n",to_points(width),to_points(height));
	printf ("%%%%Pages: 1\n");
	printf ("%%%%DocumentFonts:\n");
	printf ("%%%%EndComments\n");
	printf ("/pix %d string def\n",width);
	printf ("22 %d translate\n",to_points(height)-offset);
	printf ("%d %d scale\n",to_points(width * 0.24),to_points(height * 0.24));
	printf ("%d %d 1\n",width,height);
	/* If you want an RGB image, change that 1 to 8 */
	printf ("[%d 0 0 -%d 0 %d]\n",to_points(width),to_points(height),to_points(height));
	printf ("{currentfile pix readhexstring pop}\n");
	printf ("image\n");


	while ((c = getchar()) != EOF) {
		printf ("%2.2x",255 - c);
		byte_count++;
		if (count++ > 128) {
			printf ("\n");
			count = 0;
		}
	}
	printf("showpage\n");
	fprintf(stderr,"%d bytes in image %dx%d\n",byte_count,width,height);
}


